// Code generated by Community Administration CLI. DO NOT EDIT.

package model

import (
	"encoding/json"
	"fmt"
	"time"
)

type MemberEvent interface {
	isMemberEvent()
	GetBaseMemberEvent() BaseMemberEvent
}

type BaseMemberEvent struct {
	MemberEventType
	Date     time.Time `json:"date"`
	PersonId int       `json:"personId"`
}

func NewMemberEventFromByteSlice(byteSlice []byte) (*MemberEvent, error) {
	var memberEvent MemberEvent

	baseMemberEvent := BaseMemberEvent{}

	err := json.Unmarshal(byteSlice, &baseMemberEvent)
	if err != nil {
		return nil, fmt.Errorf("json unmarshal to BaseMemberEvent failed")
	}

	switch baseMemberEvent.Type {
	case PERSON_APPROVED:
		memberEventTypeModel := PersonApproved{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case CREATE_PAYMENT_REQUEST:
		memberEventTypeModel := CreatePaymentRequest{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case APPLICATION_FORM_SENT:
		memberEventTypeModel := ApplicationFormSent{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case PAYMENT_COMPLETED:
		memberEventTypeModel := PaymentCompleted{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case SUBSCRIPTION_FORM_RECEIVED:
		memberEventTypeModel := SubscriptionFormReceived{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case SUBSCRIPTION_PAYED:
		memberEventTypeModel := SubscriptionPayed{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case MEMBER_INFO_COMPLETED:
		memberEventTypeModel := MemberInfoCompleted{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case PAYMENT_CONFIRMATION_LETTER_CREATED:
		memberEventTypeModel := PaymentConfirmationLetterCreated{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case PAYMENT_CONFIRMATION_SENT:
		memberEventTypeModel := PaymentConfirmationSent{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case WELCOME_LETTER_SENT:
		memberEventTypeModel := WelcomeLetterSent{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case MEMBERSHIP_ID_ASSIGNED:
		memberEventTypeModel := MembershipIdAssigned{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case MEMBER_INFO_CHANGED:
		memberEventTypeModel := MemberInfoChanged{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case SUBSCRIPTION_RENEWAL_SENT:
		memberEventTypeModel := SubscriptionRenewalSent{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case MEMBERSHIP_CANCELLATION_RECEIVED:
		memberEventTypeModel := MembershipCancellationReceived{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case MEMBERSHIP_CANCELLATION_CONFIRMATION_SENT:
		memberEventTypeModel := MembershipCancellationConfirmationSent{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	case MEMBERSHIP_CANCELLED:
		memberEventTypeModel := MembershipCancelled{}
		err = json.Unmarshal(byteSlice, &memberEventTypeModel)
		memberEvent = memberEventTypeModel
	default:
		return nil, fmt.Errorf("unprocessed member event, %s", baseMemberEvent.Type)
	}

	if err != nil {
		return nil, fmt.Errorf("json unmarshal to %s failed, %v", baseMemberEvent.Type, err)
	}

	return &memberEvent, nil
}
